/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 * Copyright (c) 1982, 1986, 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)in.h	8.3 (Berkeley) 1/3/94
 * $FreeBSD: src/sys/netinet/in.h,v 1.38.2.3 1999/08/29 16:29:34 peter Exp $
 */
 
#ifndef _IN_H_
#define _IN_H_

#ifdef SUPPORT_INET6

#include <netinet6/in6.h>

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  TINET ΥС
 */

#define TINET_PRVER	0x1041u		/* TINET ΥСֹ */

/*
 *  󥿡ͥåȥƥRFC790 
 */

/*
 *  ץȥ (RFC1700)
 */

#define IPPROTO_IP		0		/* IP Υߡ				*/
#define IPPROTO_HOPOPTS		0		/* IPv6  (Hop-by-Hop) ץ	*/
#define IPPROTO_ICMP		1		/* ICMP					*/
#define IPPROTO_TCP		6		/* TCP					*/
#define IPPROTO_UDP		17		/* UDP					*/
#define IPPROTO_IPV6		41		/* IPv6					*/
#define IPPROTO_ROUTING		43		/* ϩ楪ץ			*/
#define IPPROTO_FRAGMENT	44		/* Ҳץ			*/
#define IPPROTO_RSVP		46		/* RSVP					*/
#define IPPROTO_ESP		50		/* IPv6 Ź沽ץ		*/
#define IPPROTO_AH		51		/* IPv6 ǧڥץ			*/
#define IPPROTO_ICMPV6		58		/* ICMPv6				*/
#define IPPROTO_NONE		59		/* IPv6 إå̵			*/
#define IPPROTO_DSTOPTS		60		/* IPv6 ץ			*/
#define IPPROTO_IPCOMP		108		/* ڥɰ			*/
#define IPPROTO_DONE		257		/* IPv6 Ǿ̥ץȥϽλ	*/

/*
 *  IPv4 ɥ쥹
 */

/*  */

#ifndef T_IN4_ADDR_DEFINED

typedef UW T_IN4_ADDR;

#define T_IN4_ADDR_DEFINED

#endif	/* of #ifndef T_IN4_ADDR_DEFINED */

/*
 *  ITRON TCP/IPv4 ɥ쥹/ݡֹ
 */

typedef struct t_ipv4ep {
	UW ipaddr;		/* IPv4 ɥ쥹	*/
	UH portno;		/* ݡֹ		*/
	} T_IPV4EP;

/*
 *  ɥ쥹/ݡȤĹ
 */

#define IPV4_ADDR_LEN		4
#define PORT_NUM_LEN		2

/*
 *  ݡֹ
 */

#define TCP_PORTANY			0x0000		/* ITRON TCP/IP ɸ	*/
#define UDP_PORTANY			0x0000		/* ITRON TCP/IP ɸ	*/

#define TCP_PORT_LAST_WELL_KNOWN	1023		/* Well Known λֹ	*/
#define TCP_PORT_FIRST_AUTO		1024		/* ưƳֹ	*/
#define TCP_PORT_LAST_AUTO		4999		/* ưƽλֹ	*/

#define UDP_PORT_LAST_WELL_KNOWN	1023		/* Well Known λֹ	*/
#define UDP_PORT_FIRST_AUTO		1024		/* ưƳֹ	*/
#define UDP_PORT_LAST_AUTO		4999		/* ưƽλֹ	*/

/*
 *  IP ɥ쥹
 */

#define IPV4_ADDRANY		0x00000000	/* ITRON TCP/IP ɸ	*/

#define IPV4_ADDR_LOOPBACK	0x7f000001
#define IPV4_ADDR_LOOPBACK_MASK	IPV4_CLASS_A_MASK
#define IPV4_ADDR_BROADCAST	0xffffffff

#define IPV4_CLASS_A(i)		(((i) & 0x80000000) == 0)
#define IPV4_CLASS_A_NET	0xff000000
#define IPV4_CLASS_A_MASK	0xff000000
#define IPV4_CLASS_A_HOST	0x00ffffff

#define IPV4_CLASS_B(i)		(((i) & 0xc0000000) == 0x80000000)
#define IPV4_CLASS_B_NET	0xffff0000
#define IPV4_CLASS_B_MASK	0xffff0000
#define IPV4_CLASS_B_HOST	0x0000ffff

#define IPV4_CLASS_C(i)		(((i) & 0xe0000000) == 0xc0000000)
#define IPV4_CLASS_C_NET	0xffffff00
#define IPV4_CLASS_C_MASK	0xffffff00
#define IPV4_CLASS_C_HOST	0x000000ff

#define IPV4_CLASS_D(i)		(((i) & 0xf0000000) == 0xe0000000)

#define IN4_IS_ADDR_MULTICAST(i)	IPV4_CLASS_D(i)

#define MAKE_IPV4_LOCAL_BROADCAST(i)	(IPV4_CLASS_A(i)?((i)|IPV4_CLASS_A_HOST):\
					 IPV4_CLASS_B(i)?((i)|IPV4_CLASS_B_HOST):\
					 IPV4_CLASS_C(i)?((i)|IPV4_CLASS_C_HOST):\
					 IPV4_ADDR_BROADCAST)

#define MAKE_IPV4_LOCAL_MASK(i)		(IPV4_CLASS_A(i)?IPV4_CLASS_A_MASK:\
					 IPV4_CLASS_B(i)?IPV4_CLASS_B_MASK:\
					 IPV4_CLASS_C(i)?IPV4_CLASS_C_MASK:\
					 IPV4_ADDRANY)

#define MAKE_IPV4_ADDR(a,b,c,d)		((T_IN4_ADDR)(((UW)(a)<<24)|((UW)(b)<<16)|((UW)(c)<<8)|(d)))

/*
 *  ưŪ TCP ̿ü
 */

typedef struct t_tcp_ccep {
	/* ɸ */
	ATR		cepatr;		/* ̿ü°			*/
	VP		sbuf;		/* ѥɥХåե	*/
	INT		sbufsz;		/* ѥɥХåե	*/
	VP		rbuf;		/* ѥɥХåե	*/
	INT		rbufsz;		/* ѥɥХåե	*/
	FP		callback;	/* Хå			*/
	/* ¸ */
	} T_TCP_CCEP;

#ifdef SUPPORT_INET4

/*
 *  ưŪ TCP ո
 */

typedef struct t_tcp_crep {
	/* ɸ */
	ATR		repatr;		/* ո°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹	*/
	/* ¸ */
	} T_TCP_CREP;

/*
 *  ưŪ UDP ̿ü
 */

typedef struct t_udp_ccep {
	/* ɸ */
	ATR		cepatr;		/* UDP ̿ü°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	FP		callback;	/* Хåؿ		*/
	/* ¸ */
	} T_UDP_CCEP;

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#ifdef SUPPORT_INET4

#define T_IN_ADDR			T_IN4_ADDR
#define T_IPEP				T_IPV4EP
#define IP_ADDRANY			IPV4_ADDRANY

#define IN_ARE_ADDR_EQUAL(n,h)		(*(n)==*(h))
#define IN_ARE_NET_ADDR_EQUAL(n,h)	(ntohl(*(n))==*(h))
#define IN_COPY_TO_NET(d,s)		(*(d)=htonl(*(s)))
#define IN_COPY_TO_HOST(d,s)		(*(d)=ntohl(*(s)))
#define IN_IS_ADDR_MULTICAST(a)		IN4_IS_ADDR_MULTICAST(*(a))
#define IN_IS_NET_ADDR_MULTICAST(a)	IN4_IS_ADDR_MULTICAST(ntohl(*(a)))
#define IN_IS_ADDR_ANY(a)		(*(a)==IPV4_ADDRANY)

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  TINET ȼ API
 */

extern const char *in_strtfn (FN fncd);

#ifdef SUPPORT_INET4

extern ER in4_add_ifaddr (T_IN4_ADDR addr, T_IN4_ADDR mask);
extern ER in4_add_route (int index, T_IN4_ADDR target,
                                    T_IN4_ADDR mask, T_IN4_ADDR gateway);
extern UB *ip2str (UB *buf, const T_IN4_ADDR *ipaddr);

#endif	/* of #ifdef SUPPORT_INET4 */

#endif	/* of #ifndef _IN_H_ */
