/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_icmp.h	8.1 (Berkeley) 6/10/93
 * $FreeBSD: src/sys/netinet/ip_icmp.h,v 1.12.2.2 1999/11/18 08:51:44 peter Exp $
 */
 
#ifndef _IP_ICMP_H_
#define _IP_ICMP_H_

/*
 *  ICMP إåRFC 792
 */

typedef struct t_icmp_hdr {
	UB	type;		/* åη	*/
	UB	code;		/* ַ		*/
	UH	sum;		/* å		*/
	union {
		struct id_seq {
			UH	id;
			UH	seq;
			} id_seq;
		T_IN4_ADDR	addr;
		} data;
	} T_ICMP4_HDR;

#define ICMP4_HDR_SIZE			(sizeof(T_ICMP4_HDR))
#define IP4_ICMP4_HDR_SIZE		(IP4_HDR_SIZE + ICMP4_HDR_SIZE)
#define IF_IP4_ICMP4_HDR_SIZE		(IF_IP4_HDR_SIZE + ICMP4_HDR_SIZE)
#define IF_IP4_ICMP4_HDR_OFFSET		(IF_IP4_HDR_SIZE)

#define GET_ICMP4_HDR(nbuf,ihoff)	((T_ICMP4_HDR*)((UB*)((nbuf)->buf) + ihoff))
#define GET_ICMP4_SDU(nbuf,ihoff)	((UB*)((nbuf)->buf) + ihoff + ICMP4_HDR_SIZE)

#define GET_ICMP4_HDR_OFFSET(nbuf)	(GET_IF_IP_HDR_SIZE(nbuf))

#define GET_IP4_ICMP4_HDR_SIZE(nbuf)	(GET_IP4_HDR_SIZE(GET_IP4_HDR(nbuf)) + ICMP4_HDR_SIZE)
#define GET_IF_IP4_ICMP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + GET_IP4_ICMP4_HDR_SIZE(nbuf))

/*
 *  åη
 */

#define ICMP4_ECHO_REPLY		0	/* 		*/
#define ICMP4_UNREACH		3	/* 顼		*/
#define ICMP4_SOURCE_QUENCH	4	/* ȯ		*/
#define ICMP4_REDIRECT		5	/* ѹ		*/
#define ICMP4_ECHO_REQUEST	8	/* ׵		*/
#define ICMP4_TIME_EXCEEDED	11	/* ȯ		*/
#define ICMP4_PARAMETER		12	/* ѥ᡼۾	*/
#define ICMP4_TIME_REQUEST	13	/* ॹ׵	*/
#define ICMP4_TIME_REPLY		14	/* ॹױ	*/
#define ICMP4_MASK_REQUEST	17	/* ɥ쥹ޥ׵	*/
#define ICMP4_MASK_REPLY		18	/* ɥ쥹ޥ	*/

/*
 *  ַ
 */

/* ICMP4_UNREACH (3)	*/

#define ICMP4_UNREACH_NET		0	/* ͥåȥ		*/
#define ICMP4_UNREACH_HOST		1	/* ۥ		*/
#define ICMP4_UNREACH_PROTOCOL		2	/* ץȥ		*/
#define ICMP4_UNREACH_PORT		3	/* ݡ		*/
#define ICMP4_UNREACH_FLAG		4	/* ʬ			*/
#define ICMP4_UNREACH_SRC_FAIL		5	/* ϩ		*/
#define ICMP4_UNREACH_NET_UNKNOWN	6	/* ͥåȥ	*/
#define ICMP4_UNREACH_HOST_UNKNOWN	7	/* ۥ		*/
#define ICMP4_UNREACH_ISOLATED		8	/* ʬΥ			*/
#define ICMP4_UNREACH_NET_PROHIB		9	/* 			*/
#define ICMP4_UNREACH_HOST_PROHIB	10	/* 			*/
#define ICMP4_UNREACH_TOS_NET		11	/* ͥåȥؤTOS*/
#define ICMP4_UNREACH_TOS_HOST		12	/* ۥȤؤTOS	*/
#define ICMP4_UNREACH_FILTER_PROHIB	13	/* 			*/
#define ICMP4_UNREACH_HOST_PRECEDENCE	14	/* 			*/
#define ICMP4_UNREACH_PRECEDENCE_CUTOFF	15	/* 			*/

/* ICMP4_REDIRECT (5)	*/

#define ICMP4_REDIRECT_NET		0	/* ͥåȥ		*/
#define ICMP4_REDIRECT_HOST		1	/* ۥ		*/
#define ICMP4_REDIRECT_PORT_AND_NET	2	/* ݡֹȥͥå	*/
#define ICMP4_REDIRECT_PORT_AND_HOST	3	/* ݡֹȥۥ	*/

/*
 *  ѿ
 */

/*
 *  ؿߥ졼ޥ
 */

#ifndef ICMP_REPLY_ERROR

#define _tinet_icmp_error(code,data)

#endif	/* of #ifdef ICMP_REPLY_ERROR */

/*
 *  ؿ
 */

extern UINT icmp_input (T_NET_BUF **inputp, UINT *offp, UINT *nextp);

#ifdef ICMP_REPLY_ERROR

extern void icmp_error (UB code, T_NET_BUF *data);

#endif	/* of #ifdef ICMP_REPLY_ERROR */

/*
 *  TINET ȼ API
 */

#ifdef ICMP_CFG_CALLBACK_ECHO_REPLY

extern void icmp_echo_reply (T_NET_BUF *input, UINT ihoff);

#endif	/* of #ifdef ICMP_CFG_CALLBACK_ECHO_REPLY */

#endif	/* of #ifndef _IP_ICMP_H_ */
